#!/usr/bin/perl
#file: upload.pl

use CGI qw/:standard :html3 -no_debug/;

print header,
    start_html('file upload'),
    h1('file upload');
print_form()    unless param;
print_results() if param;
print end_html;

sub print_form {
    print start_multipart_form(),
      table(
         Tr([
           td([
             'File to upload:',
             filefield(-name=>'upload',-size=>50)
           ]),
           td([
            'Server save as:',
            textfield(-name=>'saveas',
              -default=>'upload.new',
              -size=>50,
              -maxlength=>80)
           ]),
           td([
             '',
             submit(-label=>'Upload File')
           ])
         ]),
       ),
       end_form;
}

sub print_results {
    my $length;
    my $file = param('upload');
    my $saveas = param('saveas');
    if (!$file) {
	print "No file uploaded.";
	return;
    }
    print h2('File name'),$file;
    print h2('Save as'),$saveas;
    print h2('File MIME type'),
      uploadInfo($file)->{'Content-Type'};
    while (<$file>) {
	$length += length($_);
    }
    print h2('File length'),$length;
}
